//: QUE3.CPP -- simple queue with integer template argument
//. Shows non-inline function definitions
//. Adapted from "Using C++" 2nd edition, Osborne/McGraw-Hill 1992
//. by Bruce Eckel

template<class T, int size> class queue {
  T *q[size];
  int in, out; // indexes
public:
  queue() : in(0), out(0) {}
  void add(T * i);
  T* get();
};

template<class T, int size>
void queue<T, size>::add(T * i) {
  q[in++] = i;
  if(in >= size) in = 0; // wrap
}

template<class T, int size>
T* queue<T, size>::get() {
  if(out == in) return 0;
  T *result = q[out++];
  if(out >= size) out = 0;
  return result;
}

void main() {
  queue<float, 10> fq1, fq2;
  queue<float, 11> fq3;
  fq1 = fq2;  // OK -- same type
//  fq3 = fq1;  // error -- different type
}
